# korean-geocoding

 Naver Geocoding API를 활용하여, 대한민국의 주소 또는 행정구역의 위도/경도 좌표를 조회/처리하는 라이브러리 입니다. 
 해당 라이브러리는 현재 **Python 3.8** 이상을 지원합니다.
 
네이버 Geocoding API를 통해 미리 수집한 행정구역별 좌표를 빠르게 활용하거나, API를 호출하여 특정 주소에 대한 좌표값을 직접 얻을 수 있습니다. 
이외에도 각 좌표간 직선 거리 계산이나, 지리좌표계간 변환 등 좌표 데이터 처리를 위한 기능들이 준비되어 있습니다. 
 
행정구역별 위경도 데이터는 트리 형태의 Python 오브젝트 형태로 데이터를 저장하여, API 호출 또는 엑셀 파일에서 단순 검색에 비해 훨씬 속도가 빠릅니다.  

파이썬 라이브러리 사용이 필요 없이 그냥 행정구역별 위도/경도를 담은 엑셀 파일이 필요하신 분은 [여기](https://skyseven73.tistory.com/23)로

사용법은 [Wiki 페이지](https://github.com/RE-A/korean-geocoding/wiki/Usage)를 참조해 주세요.

## 주요 기능

- 대한민국의 행정구역별 위도/경도의 빠른 검색
- 상세 주소에 대한 위경도 검색은 네이버 Geocoding API를 사용하기 쉽게 래핑하여 클라이언트 키만 있으면 손쉽게 사용 가능
- 두 좌표 간 거리 계산
- 좌표계 변환(Beta)

## Update log

#### 0.4.1
- Python 3.8 이상만 지원하도록 조정(pyproj 이슈)
- README 개선


#### 0.4.0

- 행정구역을 위경도로 변환 시, `서울`, `전북` 같은 약어도 처리할 수 있도록 개선
- 네이버 API의 반환값을 디테일하게 받을 시(detail=True), 처리하기 쉽도록 구조를 단순화하여 제공


#### 0.3.0

- 사용법이 리드미가 아닌 깃헙 위키로 가도록 분리
- pyproj를 이용한 좌표 변환 기능 추가
- Naver API를 이용한 위경도 좌표 검색 기능 추가

#### 0.2.0

- 좌표가 (위도, 경도) 순으로 배치되도록 데이터 정리. -> 네이버 지도에 바로 복붙식으로 검색할 수 있습니다.
기존에 (위도, 경도)가 (경도, 위도)로 잘못 표시되었던 부분은 숫자에는 이상이 없고 순서만 바뀌어 있던 상태였습니다.
- 지역 출장소 항목들 데이터에서 삭제
- get_distance 함수 추가


#### 0.1.3

- pypi에서 descirption 보이도록 수정

#### 0.1.2

- 자잘한 많은 버그 수정
- get_under_district가 특정 조건에서 에러를 내던 버그 수정


#### 0.1.1

- 코드에서 typing.Final 키워드가 Python 3.8 이상만 지원해서 삭제
- 자잘한 버그 수정 


-----------------------------------------

## 안내

- Issue 사항이나 뭔가 필요한 기능, 개선사항이 있으시다면 언제든 여기 깃헙의 이슈나 제 블로그 게시글(아래)의 댓글에 알려 주세요.
- 위의 파일들 수정일자 보면 아시겠지만 2022년 4월 기준으로 전혀 죽은 프로젝트 아닙니다 ㅠㅠ
- 앞으로 추가될 기능들은 [여기](https://github.com/RE-A/korean-geocoding/issues/5) 서 정리하는 중입니다.
- 해당 라이브러리에 개발과 관련된 TMI는 [여기](https://skyseven73.tistory.com/24)에 업데이트 될 예정입니다.
